/*
 * Name:     CInstructionFactory
 * Author:   Martin Perner, 0725782, 535
 * E-Mail:   e0725782@student.tuwien.ac.at
 * Purpose:  Factory for creating commands from shared libraries
 * Date:     29.04.2009
 */

#ifndef __CINSTRUCTIONFACTORY_H__
#define __CINSTRUCTIONFACTORY_H__

#include "Iinstr.hpp"

#include <string.h>

#include <iostream>
#include <sstream>
#include <map>
#include <vector>
#include <algorithm>

#include <dlfcn.h>
#include <errno.h>

#include <dirent.h>

/**
 * Name:    CInstructionFactory
 * Purpose: Factory for creating commands from shared libraries
 */
class CInstrFactory {
private:
	std::map<void*, Iinstr*> m_libStore;
	std::vector<std::string> m_files;

	Iinstr* loadFromLib(std::string lib);
public:
	Iinstr* getNextInstr();
	size_t getNumFiles();
	size_t searchLibsInDir(std::string dir);
	void loadLibsIntoMap(map<short, Iinstr*>& instr, string dir);
	CInstrFactory() : m_libStore(), m_files() {};
	~CInstrFactory();
};

#endif
